/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

struct X {
   int i ;
};
/*@ ensures *\old(item) == \old(*item); */
void __gen_e_acsl_f(struct X *item);

void f(struct X *item)
{
  __e_acsl_store_block((void *)(& item),(size_t)8);
  __e_acsl_delete_block((void *)(& item));
  return;
}

int main(void)
{
  int __retres;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  struct X x = {.i = 1};
  __e_acsl_store_block((void *)(& x),(size_t)4);
  __e_acsl_full_init((void *)(& x));
  __gen_e_acsl_f(& x);
  __retres = 0;
  __e_acsl_delete_block((void *)(& x));
  __e_acsl_memory_clean();
  return __retres;
}

/*@ ensures *\old(item) == \old(*item); */
void __gen_e_acsl_f(struct X *item)
{
  struct X __gen_e_acsl_at_2;
  struct X *__gen_e_acsl_at;
  __e_acsl_store_block((void *)(& item),(size_t)8);
  {
    int __gen_e_acsl_valid_read;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"item",
                                 (void *)item);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                   "sizeof(struct X)",0,sizeof(struct X));
    __gen_e_acsl_valid_read = __e_acsl_valid_read((void *)item,
                                                  sizeof(struct X),
                                                  (void *)item,
                                                  (void *)(& item));
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "RTE";
    __gen_e_acsl_assert_data_2.pred_txt = "mem_access: \\valid_read(item)";
    __gen_e_acsl_assert_data_2.file = "tests/bts/issue-eacsl-139.c";
    __gen_e_acsl_assert_data_2.fct = "f";
    __gen_e_acsl_assert_data_2.line = 9;
    __e_acsl_assert(__gen_e_acsl_valid_read,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
    __gen_e_acsl_at_2 = *item;
  }
  __gen_e_acsl_at = item;
  f(item);
  __e_acsl_delete_block((void *)(& item));
  return;
}


